package submit.aiwolf.wordwolf;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Player;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;
import org.aiwolf.sample.player.*;


public abstract class BaseRoleAssignPlayer implements Player {

    @Override
    public String getName() {
        return "DemoRoleAssignPlayer";
    }

    public abstract void setTF(TalkFrequencyModel tf);

    public abstract TalkFrequencyModel getTF();

    private Player villagerPlayer = new SampleVillager();
    private Player seerPlayer = new SampleSeer();
    private Player mediumPlayer = new SampleMedium();
    private Player bodyguardPlayer = new SampleBodyguard();
    private Player possessedPlayer = new SamplePossessed();
    private Player werewolfPlayer = new SampleWerewolf();
    private Player rolePlayer;
    private Player villagerPlayer5 = new SampleVillager();
    private Player seerPlayer5 = new SampleSeer();
    private Player possessedPlayer5 = new SamplePossessed();
    private Player werewolfPlayer5 = new SampleWerewolf();

    public final Player getVillagerPlayer() {
        return this.villagerPlayer;
    }

    public final void setVillagerPlayer(Player villagerPlayer) {
        this.villagerPlayer = villagerPlayer;
    }

    public final Player getSeerPlayer() {
        return this.seerPlayer;
    }

    public final void setSeerPlayer(Player seerPlayer) {
        this.seerPlayer = seerPlayer;
    }

    public final Player getMediumPlayer() {
        return this.mediumPlayer;
    }

    public final void setMediumPlayer(Player mediumPlayer) {
        this.mediumPlayer = mediumPlayer;
    }

    public final Player getBodyguardPlayer() {
        return this.bodyguardPlayer;
    }

    public final void setBodyguardPlayer(Player bodyGuardPlayer) {
        this.bodyguardPlayer = bodyGuardPlayer;
    }

    public final Player getPossessedPlayer() {
        return this.possessedPlayer;
    }

    public final void setPossessedPlayer(Player possesedPlayer) {
        this.possessedPlayer = possesedPlayer;
    }

    public final Player getWerewolfPlayer() {
        return this.werewolfPlayer;
    }

    public final void setWerewolfPlayer(Player werewolfPlayer) {
        this.werewolfPlayer = werewolfPlayer;
    }

    public final Player getVillagerPlayer5() {
        return this.villagerPlayer5;
    }

    public final void setVillagerPlayer5(Player villagerPlayer) {
        this.villagerPlayer5 = villagerPlayer;
    }

    public final Player getSeerPlayer5() {
        return this.seerPlayer5;
    }

    public final void setSeerPlayer5(Player seerPlayer) {
        this.seerPlayer5 = seerPlayer;
    }

    public final Player getPossessedPlayer5() {
        return this.possessedPlayer5;
    }

    public final void setPossessedPlayer5(Player possesedPlayer) {
        this.possessedPlayer5 = possesedPlayer;
    }

    public final Player getWerewolfPlayer5() {
        return this.werewolfPlayer5;
    }

    public final void setWerewolfPlayer5(Player werewolfPlayer) {
        this.werewolfPlayer5 = werewolfPlayer;
    }

    public final void update(GameInfo gameInfo) {
        this.rolePlayer.update(gameInfo);
    }

    public final void initialize(GameInfo gameInfo, GameSetting gameSetting) {
        Role myRole = gameInfo.getRole();
        if (gameInfo.getAgentList().size() == 5) {
            switch (myRole) {
                case VILLAGER:
                default:
                    this.rolePlayer = this.villagerPlayer5;
                    break;
                case POSSESSED:
                    this.rolePlayer = this.possessedPlayer5;
                    break;
                case SEER:
                    this.rolePlayer = this.seerPlayer5;
                    break;
                case WEREWOLF:
                    this.rolePlayer = this.werewolfPlayer5;
            }
        } else {
            switch (myRole) {
                case BODYGUARD:
                    this.rolePlayer = this.bodyguardPlayer;
                    break;
                case VILLAGER:
                default:
                    this.rolePlayer = this.villagerPlayer;
                    break;
                case MEDIUM:
                    this.rolePlayer = this.mediumPlayer;
                    break;
                case POSSESSED:
                    this.rolePlayer = this.possessedPlayer;
                    break;
                case SEER:
                    this.rolePlayer = this.seerPlayer;
                    break;
                case WEREWOLF:
                    this.rolePlayer = this.werewolfPlayer;
            }
        }

        this.rolePlayer.initialize(gameInfo, gameSetting);
    }

    public final void dayStart() {
        this.rolePlayer.dayStart();
    }

    public final String talk() {
        return this.rolePlayer.talk();
    }

    public final String whisper() {
        return this.rolePlayer.whisper();
    }

    public final Agent vote() {
        return this.rolePlayer.vote();
    }

    public final Agent attack() {
        return this.rolePlayer.attack();
    }

    public final Agent divine() {
        return this.rolePlayer.divine();
    }

    public final Agent guard() {
        return this.rolePlayer.guard();
    }

    public final void finish() {
        this.rolePlayer.finish();
    }

    public BaseRoleAssignPlayer() {
        setVillagerPlayer(new villager());
        setBodyguardPlayer(new DemoBodyguard());
        setMediumPlayer(new DemoMedium());
        setSeerPlayer(new DemoSeer());
        setPossessedPlayer(new DemoPossessed());
        setWerewolfPlayer(new DemoWerewolf());
        setVillagerPlayer5(new villager5());
        setSeerPlayer5(new DemoSeer5());
        setPossessedPlayer5(new DemoPossessed5());
        setWerewolfPlayer5(new DemoWerewolf5());
    }
}
