package submit.aiwolf.wordwolf;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class DemoBodyguard extends villager {
	Agent guardedAgent;
	List<Agent> guardSuccessedAgent = new ArrayList<>();
	List<Agent> possessedList = new ArrayList<>();
	List<Agent> blackList = new ArrayList<>();
	boolean seerDead = false;
	boolean mediumDead = false;

	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		guardedAgent = null;
		guardSuccessedAgent = new ArrayList<>();
		possessedList = new ArrayList<>();
		blackList = new ArrayList<>();
		seerDead = false;
		mediumDead = false;
	}

	@Override
	public void setWhiteList() {
		whiteList.clear();
		grayList.clear();

		if (day > 3) {
			Agent candidate = me;
			for (Agent agent : SeerCOAgent) {
				if (!blackList.contains(agent) && !possessedList.contains(agent)
						&& tf.getRoleProbability(agent, Role.SEER) > tf.getRoleProbability(candidate, Role.SEER)) {
					candidate = agent;
				}
			}
			if (candidate != me) {
				for (Agent agent : humanAgentMap.get(candidate)) {
					whiteList.add(agent);
				}
				for (Agent agent : wolfAgentMap.get(candidate)) {
					grayList.add(agent);
				}
			}
			return;
		}

		for (Agent seerAgent : SeerCOAgent) {
			if (!blackList.contains(seerAgent) && !possessedList.contains(seerAgent)) {
				for (Agent agent : humanAgentMap.get(seerAgent)) {
					whiteList.add(agent);
				}
				for (Agent agent : wolfAgentMap.get(seerAgent)) {
					grayList.add(agent);
				}
			}
		}
	}


	@Override
	public void dayStart() {
		super.dayStart();
		if (currentGameInfo.getLastDeadAgentList().isEmpty()) {
			guardSuccessedAgent.add(latestGameInfo.getGuardedAgent());
		}
		for (Agent agent : currentGameInfo.getLastDeadAgentList()) {
			if (isCo(agent)&&!blackList.contains(agent)&&!possessedList.contains(agent)) {
				if (comingoutMap.get(agent) == Role.SEER) {
					seerDead = true;
				} else if (comingoutMap.get(agent) == Role.MEDIUM) {
					mediumDead = true;
				}
			}
		}
	}



	@Override
	public void chooseVoteCandidate() {
		werewolves.clear();


		for (Judge j : identList) {
			if (j.getResult() == Species.WEREWOLF && (guardSuccessedAgent.contains(j.getTarget())||j.getTarget()==me)) {
				Agent candidate = j.getAgent();
				if (isAlive(candidate) && !werewolves.contains(candidate)) {
					if (!guardSuccessedAgent.contains(candidate)) {
						werewolves.add(candidate);
						if (!blackList.contains(candidate)) {
							blackList.add(candidate);
							for (Role role : Role.values()) {
								if (role == Role.FOX || role == Role.FREEMASON) {
									continue;
								}
								if (role != Role.POSSESSED && role != Role.WEREWOLF) {
									tf.updateRoleProbability(candidate, role, false, currentGameInfo);
								}
							}
						}
					} else {
						if (!possessedList.contains(candidate)) {
							possessedList.add(candidate);
							tf.updateRoleProbability(candidate, Role.POSSESSED, true, latestGameInfo);
						}
					}
				}
			}
		}

		for (Judge j : divinationList) {
			if (j.getResult() == Species.WEREWOLF && (j.getTarget() == me
					|| isKilled(j.getTarget()) || guardSuccessedAgent.contains(j.getTarget()))) {
				Agent candidate = j.getAgent();
				if (isAlive(candidate) && !werewolves.contains(candidate)) {
					if (!guardSuccessedAgent.contains(j.getTarget())) {
						werewolves.add(candidate);
						if (!blackList.contains(candidate)) {
							blackList.add(candidate);
							for (Role role : Role.values()) {
								if (role == Role.FOX || role == Role.FREEMASON) {
									continue;
								}
								if (role != Role.POSSESSED && role != Role.WEREWOLF) {
									tf.updateRoleProbability(candidate, role, false, currentGameInfo);
								}
							}
						}
					} else {
						possessedList.add(candidate);
						tf.updateRoleProbability(candidate, Role.POSSESSED, true, latestGameInfo);
					}
				}
			}
		}

		super.chooseVoteCandidate();
	}

	public Agent guard() {
		Agent guardCandidate = null;
		//役職持ち相手に護衛成功した場合は連続護衛を行う
		if (guardedAgent != null && isAlive(guardedAgent) &&
				currentGameInfo.getLastDeadAgentList().isEmpty() && isCo(guardedAgent)) {
			if (!werewolves.contains(guardedAgent)
					&& !possessedList.contains(guardedAgent) && !blackList.contains(guardedAgent)) {
				guardCandidate = guardedAgent;
			}
		} else {
			List<Agent> candidates = new ArrayList<>();
			//白で見れる占い師の護衛を最優先で行う
			if (!seerDead) {
				for (Agent agent : aliveOthers) {
					if (comingoutMap.get(agent) == Role.SEER && !werewolves.contains(agent)
							&& !possessedList.contains(agent) && !blackList.contains(agent)) {
						candidates.add(agent);
					}
				}
			}
			//占い師がいなければ白で見れる霊媒師の護衛を行う
			if (!mediumDead) {
				if (candidates.isEmpty()) {
					for (Agent agent : aliveOthers) {
						if (comingoutMap.get(agent) == Role.MEDIUM && !werewolves.contains(agent)
								&& !possessedList.contains(agent) && !blackList.contains(agent)) {
							candidates.add(agent);
						}
					}
				}
			}
			if (candidates.isEmpty()) {
				for (Agent agent : aliveOthers) {
					if (!werewolves.contains(agent) && !svmMap.keySet().contains(agent)
							&& !possessedList.contains(agent) && !blackList.contains(agent)) {
						candidates.add(agent);
					}
				}
			}
			if (candidates.isEmpty()) {
				candidates.addAll(aliveOthers);
			}

			double tmp=0.0;
			Agent candidate=me;
			for(Agent agent:candidates) {
				double tmp2=tf.getRoleProbability(agent, Role.VILLAGER);
				if(tmp<tmp2) {
					tmp=tmp2;
					candidate=agent;
				}
			}
			guardCandidate = candidate;
		}
		guardedAgent = guardCandidate;
		return guardCandidate;
	}
}
