package submit.aiwolf.wordwolf;

import java.util.*;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.IdentContentBuilder;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class DemoMedium extends villager {
	int comingoutDay;
	boolean isCameout;
	Deque<Judge> identQueue = new LinkedList<>();
	Map<Agent,Species> myIdentMap=new HashMap<>();

	@Override
	public void initialize(GameInfo gameInfo,GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		comingoutDay=(int)(Math.random() * 0 +1);
		isCameout=false;
		identQueue.clear();
		myIdentMap.clear();
	}

	@Override
	public void update(GameInfo gameInfo){
		super.update(gameInfo);
	}

	@Override
	public Agent vote() {
		return super.vote();
	}

	@Override
	public void dayStart() {
		super.dayStart();
		Judge ident = currentGameInfo.getMediumResult();
		if(ident!=null) {
			identQueue.offer(ident);
			myIdentMap.put(ident.getTarget(), ident.getResult());
		}
	}

	@Override
	public void chooseVoteCandidate() {
		werewolves.clear();

		//噛まれた人または自分を人狼扱いした,または自分の霊媒結果と矛盾する占いは人狼サイド
		for(Judge j:divinationList) {
			Agent agent=j.getAgent();
			Agent target=j.getTarget();
			if(j.getResult()==Species.WEREWOLF && (target==me ||
					isKilled(target))||(myIdentMap.containsKey(target)&&j.getResult()!=myIdentMap.get(target))) {
				if(isAlive(agent)&&!werewolves.contains(agent)) {
					werewolves.add(agent);
					for (Role role : Role.values()) {
						if (role == Role.FOX || role == Role.FREEMASON) {
							continue;
						}
						if (role != Role.POSSESSED && role != Role.WEREWOLF) {
							tf.updateRoleProbability(agent, role, false, latestGameInfo);
						}
					}
				}
			}
		}
		super.chooseVoteCandidate();
	}

	@Override
	public void setWhiteList() {
		super.setWhiteList();
	}

	@Override
	public void addKilledAgent(Agent killedAgent) {
		super.addKilledAgent(killedAgent);
	}

	@Override
	public void addExecutedAgent(Agent executedAgent) {
		super.addExecutedAgent(executedAgent);
	}

	@Override
	public void AnalysisOfGuess(GameInfo gameInfo) {
		super.AnalysisOfGuess(gameInfo);
	}


	//votingMap(投票予定先)の更新

	@Override
	public void setVoteMap(List<Talk> talkList) {
		super.setVoteMap(talkList);
	}

	@Override
	public void setCOPlus(List<Talk> talkList) {
		super.setCOPlus(talkList);
	}

	@Override
	void considerVote(List<Agent> majorityList) {
		super.considerVote(majorityList);
	}

	@Override
	public void considerOthersVote() {
		super.considerOthersVote();
	}

	@Override
	public String talk() {
		if(!isCameout && (day>=comingoutDay||(!identQueue.isEmpty() &&
				identQueue.peekLast().getResult()==Species.WEREWOLF)||
				isCo(Role.MEDIUM))) {
			talkQueue.offer(new Content(new ComingoutContentBuilder(me,Role.MEDIUM)));
			isCameout=true;
		}
		if(isCameout) {
			while(!identQueue.isEmpty()) {
				Judge ident=identQueue.poll();

				if(ident.getResult()== Species.HUMAN) {
					tf.updateRoleProbability(ident.getTarget(),Role.WEREWOLF,false, latestGameInfo);
				}else {
					for (Role role : Role.values()) {
						if (role == Role.FOX || role == Role.FREEMASON) {
							continue;
						}
						if (role != Role.POSSESSED && role != Role.WEREWOLF) {
							tf.updateRoleProbability(ident.getTarget(), role, false, latestGameInfo);
						}
					}
				}
				talkQueue.offer(new Content(new IdentContentBuilder(ident.getTarget(),ident.getResult())));
			}
		}
		return super.talk();
	}
}
