package submit.aiwolf.wordwolf;

import java.util.ArrayList;
import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.data.Vote;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class DemoPossessed extends villager {
	//生存率高めなので途中(4日目以降とか)からもっと派手にかき乱すべき
	//生存率が高めなのでもう少し派手にかき回すのもありかも
	int numWolves;
	boolean isCameout;
	List<Judge> fakeDivinationList = new ArrayList<>();
	Deque<Judge> fakeDivinationQueue = new LinkedList<>();
	List<Agent> divinedAgents = new ArrayList<>();
	int talkTurn;
	// 投票予定map
	Map<Agent, Agent> votingMap;
	//ゲーム情報
	public GameInfo latestGameInfo;
	// その日のログの何番目まで読み込んだか
	int readTalkNum;
	List<Map<Agent, Agent>> votingMapHistory = new ArrayList<>();
	Role fakeRole = null;
	List<Agent> wolfCandidates = new ArrayList<>();

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		numWolves = gameSetting.getRoleNumMap().get(Role.WEREWOLF);
		isCameout = false;
		fakeDivinationList.clear();
		fakeDivinationQueue.clear();
		divinedAgents.clear();
		// 投票予定map
		votingMap = new HashMap<>();
		// その日のログの何番目まで読み込んだか
		readTalkNum = 0;
		if (Math.random() > 0.5) {
			fakeRole = Role.VILLAGER;
		} else {
			fakeRole = Role.SEER;
		}
		votingMapHistory = new ArrayList<>();
		wolfCandidates.clear();
	}

	@Override
	public void update(GameInfo gameInfo) {
		latestGameInfo = gameInfo;
		super.update(gameInfo);
		// 計測したい処理を記述

		// 今日のログを取得
		List<Talk> talkList = latestGameInfo.getTalkList();

		// voting,votedMapの更新
		setVoteMap(talkList);

		// readTalkNumの更新
		readTalkNum = talkList.size();

		setWolfCandidates();
	}

	public void setWolfCandidates() {
		List<Agent> others = latestGameInfo.getAgentList();
		others.remove(me);
		wolfCandidates.clear();
		for (Agent agent : aliveOthers) {
			if (wolfCandidates.size() < 3 - day / 2) {
				wolfCandidates.add(agent);
			} else {
				Agent candidate = agent;
				wolfCandidates.add(agent);
				double tmp = 2.0;
				for (Agent wolf : wolfCandidates) {
					if (tf.getRoleProbability(wolf, Role.WEREWOLF) < tmp) {
						tmp = tf.getRoleProbability(wolf, Role.WEREWOLF);
						candidate = wolf;
					}
				}
				wolfCandidates.remove(candidate);
			}
		}
	}


	//votingMap(投票予定先)の更新
	@Override
	public void setVoteMap(List<Talk> talkList) {
		if (latestGameInfo.getAliveAgentList().contains(
				latestGameInfo.getAgent())) {
			for (int i = readTalkNum; i < talkList.size(); i++) {
				Talk talk = talkList.get(i);
				// 発話をパース
				Content content = new Content(talk.getText());//修正
				Agent subject = talk.getAgent();
				Agent target = content.getTarget();//修正
				switch (content.getTopic()) {
				case VOTE:
					if (latestGameInfo.getAliveAgentList().contains(target)) {// vote対象が生きていないなら意味ない
						votingMap.put(subject, target);
					}
					break;
				case COMINGOUT:
					if (target == subject) {
						switch (content.getRole()) {
						case WEREWOLF:
							if (!blackList.contains(target)) {
								blackList.add(target);
							}
						default:
							break;
						}
					}
					break;
				case DIVINATION:
					if (target == me && content.getResult() == Species.WEREWOLF) {
						if (!blackList.contains(subject)) {
							blackList.add(subject);
						}
					}
				default:
					break;
				}
			}
		}
	}

	public Judge getFakeDivination() {
		Agent target = null;
		List<Agent> candidates = new ArrayList<>();

		if (day == 1 && firstCandidate != null) {
			if (Math.random() > 0.5) {
				return new Judge(day, me, firstCandidate, Species.WEREWOLF);
			} else {
				return new Judge(day, me, firstCandidate, Species.HUMAN);
			}
		}

		if (day == 2) {
			for (Judge judge : divinationList) {
				if (judge.getAgent() != me && judge.getResult() == Species.HUMAN) {
					return new Judge(day, me, judge.getTarget(), Species.WEREWOLF);
				}
			}
			for (Map.Entry<Agent, Role> rolemap : comingoutMap.entrySet()) {
				if (rolemap.getValue() == Role.MEDIUM && rolemap.getKey()!=me) {
					return new Judge(day, me, rolemap.getKey(), Species.WEREWOLF);
				}
			}
		}

		int nFakeWolves = 0;
		for (Judge j : fakeDivinationList) {
			if (j.getResult() == Species.WEREWOLF) {
				nFakeWolves++;
			}
		}

		if (!wolfCandidates.isEmpty()&& day>=5) {
			candidates.add(considerVoteToSVMWerewolves());
		}

		if (!candidates.isEmpty()) {
			target = randomSelect(candidates);
			if (nFakeWolves < numWolves && !target.equals(me)) {
				return new Judge(day, me, target, Species.WEREWOLF);
			}
		}

		candidates.remove(me);

		for (Agent a : aliveOthers) {
			if (!divinedAgents.contains(a) && comingoutMap.get(a) != Role.SEER) {
				candidates.add(a);
			}
		}

		boolean pushBlack = false;
		if (nFakeWolves < numWolves && Math.random() < 0.30) {
			pushBlack = true;
		}

		if (!candidates.isEmpty()) {
			if (pushBlack) {
				target = divineForWereWolf(candidates);
			} else {
				target = randomSelect(candidates);
			}
		} else {
			if (pushBlack) {
				target = divineForWereWolf(aliveOthers);
			} else {
				target = randomSelect(aliveOthers);
			}
		}
		Species result = Species.HUMAN;

		if (nFakeWolves < numWolves && (Math.random() < 0.50 || pushBlack)) {
			result = Species.WEREWOLF;
		}
		return new Judge(day, me, target, result);
	}

	public Agent divineForWereWolf(List<Agent> villagerList) {
		double tmp = 0.0;
		Agent candidate = me;
		double tmp2 = 0.0;
		Agent candidate2 = me;
		for (Agent agent : villagerList) {
			if(latestGameInfo.getAgentList().size()==15) {
				if (tf.getRoleProbability(agent, Role.BODYGUARD) > tmp) {
					tmp = tf.getRoleProbability(agent, Role.BODYGUARD);
					candidate = agent;
				}
			}
			if (tf.getRoleProbability(agent, Role.VILLAGER) > tmp2) {
				tmp = tf.getRoleProbability(agent, Role.VILLAGER);
				candidate2 = agent;
			}
		}
		if (candidate != me && tmp > 0.3) {
			return candidate;
		} else {
			return candidate2;
		}
	}

	@Override
	public void dayStart() {
		super.dayStart();
		revoted = false;
		talkTurn = -1;
		if (day > 0) {
			Judge judge = getFakeDivination();
			if (judge != null) {
				fakeDivinationList.add(judge);
				fakeDivinationQueue.offer(judge);
				divinedAgents.add(judge.getTarget());
			}
		}
	}

	@Override
	public void considerOthersVote() {
		//被投票数をエージェントごとに取得
		HashMap<Agent, Integer> termMap = new HashMap<Agent, Integer>();
		Agent maxVoted = me;

		termMap.put(me, 0);
		for (Agent agent : werewolves) {
			if (isAlive(agent)) {
				termMap.put(agent, 0);
			}

		}

		termMap.put(voteCandidate, 0);
		for (Map.Entry<Agent, Agent> entry : votingMap.entrySet()) {
			int count = 1;
			if (termMap.containsKey(entry.getValue())) {
				count += termMap.get(entry.getValue());
			}
			if (entry.getValue() != null) {
				termMap.put(entry.getValue(), count);
			}
		}

		//現在の最大被投票者を選出
		for (Map.Entry<Agent, Integer> entry : termMap.entrySet()) {
			if (termMap.get(maxVoted) < entry.getValue()) {
				maxVoted = entry.getKey();
			}
		}

		//自分が吊られそうな場合は自分以外で最も票の多いエージェントに投票してつられないように動く
		if (maxVoted.equals(me) || werewolves.contains(maxVoted)) {
			Agent candidate = maxVoted;
			for (Map.Entry<Agent, Integer> entry : termMap.entrySet()) {
				if (termMap.get(candidate) <= entry.getValue()+1 && me != entry.getKey()
						&& !werewolves.contains(entry.getKey())) {
					candidate = entry.getKey();
				}
			}
			if (candidate != maxVoted) {
				voteCandidate = candidate;
			}
		}
		if(termMap.get(maxVoted)>3 && termMap.get(voteCandidate)+1 < termMap.get(maxVoted) && maxVoted!=me){
			voteCandidate=maxVoted;
		}
	}

	public Agent considerVoteToSVMWerewolves() {
		//人狼推定で確率の高い3人への過去の投票数をエージェントごとに取得
		HashMap<Agent, Integer> termHistoryMap = new HashMap<Agent, Integer>();
		Agent divineCandidate = me;
		for (Agent agent : aliveOthers) {
			if (isAlive(agent)) {
				termHistoryMap.put(agent, 0);
			}
		}

		int i=0;
		//グレーの中から人狼である確率上位3人または自分への過去の投票回数のカウント
		for (Map<Agent, Agent> votingHistory : votingMapHistory) {
			i+=1;
			if(day>3){
				if(i<day-3){
					continue;
				}
			}
			for (Agent agent : aliveOthers) {
				int count = i +3 - day;
				if (wolfCandidates.contains(votingHistory.get(agent))) {
					count += termHistoryMap.get(agent);
					termHistoryMap.put(agent, count);
				}
			}
		}

		for (Agent agent : aliveOthers) {
			int count = i +4 - day;

			if(!votingMap.containsKey(agent)||votingMap.get(agent)==null){
				continue;
			}

			if (wolfCandidates.contains(votingMap.get(agent))) {
				count += termHistoryMap.get(agent);
				termHistoryMap.put(agent, count);
			}
		}

		boolean flag = false;
		//人狼である確率上位3人に今まで最も票を入れたエージェントを選出する
		for (Agent agent : aliveOthers) {
			if (!divinedAgents.contains(agent) && (day > 4 || comingoutMap.get(agent) != Role.SEER)) {
				if (!flag) {
					flag = true;
					divineCandidate = agent;
					continue;
				}
				if (termHistoryMap.get(agent) > termHistoryMap.get(divineCandidate)) {
					divineCandidate = agent;
				}
			}
		}
		return divineCandidate;
	}

	@Override
	public Agent vote() {
		super.vote();
		if (latestGameInfo.getAliveAgentList().size() == 3) {
			if (!revoted) {
				voteCandidate = null;
				for (Agent agent : latestGameInfo.getAliveAgentList()) {
					if (!blackList.contains(agent) && agent != me) {
						voteCandidate = agent;
					}
				}
				if (voteCandidate == null) {
					voteCandidate = randomSelect(latestGameInfo.getAliveAgentList());
				}
				revoted = true;
			} else {
				for (Agent agent : aliveOthers) {
					if (agent != voteCandidate) {
						voteCandidate = agent;
						break;
					}
				}
			}
			return voteCandidate;
		}

//		if (day >= 4) {
//			chooseVillager();
//			return voteCandidate;
//		}

		if (!revoted) {
			canTalk = false;
			chooseVoteCandidate();
			considerOthersVote();
			revoted = true;
		} else {
			Map<Agent, Integer> voteMap = new HashMap<Agent, Integer>();
			for (Agent agent : latestGameInfo.getAliveAgentList()) {
				voteMap.put(agent, 0);
			}
			for (Vote vote : latestGameInfo.getLatestVoteList()) {
				if (!isAlive(vote.getTarget())) {
					continue;
				}
				int count = 1;
				count += voteMap.get(vote.getTarget());
				voteMap.put(vote.getTarget(), count);
			}

			for (Agent agent : latestGameInfo.getAliveAgentList()) {
				if (!isAlive(voteCandidate) || (voteMap.get(voteCandidate) < voteMap.get(agent) && agent != me && !werewolves.contains(agent))) {
					voteCandidate = agent;
				}
			}
		}
		return voteCandidate;
	}

	public void chooseVillager() {
		werewolves.clear();
		List<Agent> candidates = latestGameInfo.getAliveAgentList();

		for (Judge judge : divinationList) {
			if ((judge.getTarget() == me || isKilled(judge.getTarget()))
					&& judge.getResult() == Species.WEREWOLF) {
				werewolves.add(judge.getAgent());
			}
		}
		candidates.removeAll(werewolves);
		List<Agent> fixedCandidates = candidates;
		for (Agent agent : wolfCandidates) {
			if (isAlive(agent)) {
				fixedCandidates.remove(agent);
			}
		}
		if (!fixedCandidates.isEmpty()) {
			voteForWereWolf(fixedCandidates);
		} else if (!candidates.isEmpty()) {
			voteForWereWolf(candidates);
		} else {
			voteForWereWolf(aliveOthers);
		}
	}

	public void voteForWereWolf(List<Agent> villagerList) {
		double tmp = 0.0;
		Agent candidate = me;
		double tmp2 = 0.0;
		Agent candidate2 = me;
		for (Agent agent : villagerList) {
			if(latestGameInfo.getAgentList().size()==15) {
				if (tf.getRoleProbability(agent, Role.BODYGUARD) > tmp) {
					tmp = tf.getRoleProbability(agent, Role.BODYGUARD);
					candidate = agent;
				}
			}
			if (tf.getRoleProbability(agent, Role.VILLAGER) > tmp2) {
				tmp = tf.getRoleProbability(agent, Role.VILLAGER);
				candidate2 = agent;
			}
		}
		if (candidate != me && tmp > 0.3) {
			voteCandidate = candidate;
		} else if (candidate != me) {
			voteCandidate = candidate2;
		}
	}

	@Override
	public void chooseVoteCandidate() {
		werewolves.clear();
		List<Agent> candidates = new ArrayList<>();

		//自分または噛まれた人に黒出しした相手は人狼と考える
		for (Judge j : divinationList) {
			if (j.getResult() == Species.WEREWOLF && (j.getTarget() == me ||
					isKilled(j.getTarget()))) {
				if (!werewolves.contains(j.getAgent())) {
					werewolves.add(j.getAgent());
				}
			}
		}

		List<Agent> fakeHumans = new ArrayList<>();
		if (fakeRole == Role.SEER) {
			for (Judge j : fakeDivinationList) {
				if (j.getResult() == Species.HUMAN) {
					if (!fakeHumans.contains(j.getTarget())) {
						fakeHumans.add(j.getTarget());
					}
				} else {
					if (!candidates.contains(j.getTarget())) {
						candidates.add(j.getTarget());
					}
				}
			}
		}
		if (candidates.isEmpty()) {
			for (Agent a : aliveOthers) {
				if (!werewolves.contains(a) && !fakeHumans.contains(a)) {
					candidates.add(a);
				}
			}
		}
		if (candidates.isEmpty()) {
			for (Agent a : aliveOthers) {
				if (!werewolves.contains(a)) {
					candidates.add(a);
				}
			}
		}
		if (!candidates.contains(voteCandidate)) {
			voteCandidate = randomSelect(candidates);
		}
	}

	@Override
	public String talk() {
		canTalk = true;
		talkTurn++;
		//残り3人になったら狂人CO
		if (latestGameInfo.getAliveAgentList().size() == 3) {
			talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.POSSESSED)));
		}
		if(talkTurn<5){
			chooseVoteCandidate();
		}else {
			considerOthersVote();
		}

		if (!isCameout && fakeRole == Role.SEER) {
			talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.SEER)));
			isCameout = true;
		}

		if (isCameout) {
			while (!fakeDivinationQueue.isEmpty()) {
				Judge divination = fakeDivinationQueue.poll();
				talkQueue.offer(
						new Content(new DivinedResultContentBuilder(divination.getTarget(), divination.getResult())));
			}
		}

		if (voteCandidate != null && voteCandidate != declaredVoteCandidate) {
			talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
			declaredVoteCandidate = voteCandidate;
		}

		return talkQueue.isEmpty() ? Talk.SKIP : talkQueue.poll().getText();

	}
}
