package submit.aiwolf.wordwolf;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import java.util.*;

public class DemoPossessed5 extends villager5 {
    //生存率高めなので途中(4日目以降とか)からもっと派手にかき乱すべき
    //生存率が高めなのでもう少し派手にかき回すのもありかも
    int numWolves;
    boolean isCameout;
    List<Judge> fakeDivinationList = new ArrayList<>();
    Deque<Judge> fakeDivinationQueue = new LinkedList<>();
    List<Agent> divinedAgents = new ArrayList<>();
    int talkTurn;
    // 投票予定map
    Map<Agent, Agent> votingMap;
    //ゲーム情報
    public GameInfo latestGameInfo;
    // その日のログの何番目まで読み込んだか
    int readTalkNum;
    List<Map<Agent, Agent>> votingMapHistory = new ArrayList<>();
    Role fakeRole = null;

    @Override
    public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
        super.initialize(gameInfo, gameSetting);
        numWolves = gameSetting.getRoleNumMap().get(Role.WEREWOLF);
        isCameout = false;
        fakeDivinationList.clear();
        fakeDivinationQueue.clear();
        divinedAgents.clear();
        // 投票予定map
        votingMap = new HashMap<>();
        // その日のログの何番目まで読み込んだか
        readTalkNum = 0;
        if (Math.random() > 0.80) {
            fakeRole = Role.VILLAGER;
        } else {
            fakeRole = Role.SEER;
        }
        votingMapHistory = new ArrayList<>();
    }

    @Override
    public void update(GameInfo gameInfo) {
        latestGameInfo = gameInfo;
        super.update(gameInfo);
        // 計測したい処理を記述

        // 今日のログを取得
        List<Talk> talkList = latestGameInfo.getTalkList();

        // voting,votedMapの更新
        setVoteMap(talkList);

        // readTalkNumの更新
        readTalkNum = talkList.size();
    }


    //votingMap(投票予定先)の更新
    @Override
    public void setVoteMap(List<Talk> talkList) {
        if (latestGameInfo.getAliveAgentList().contains(
                latestGameInfo.getAgent())) {
            for (int i = readTalkNum; i < talkList.size(); i++) {
                Talk talk = talkList.get(i);
                // 発話をパース
                Content content = new Content(talk.getText());//修正
                Agent subject = talk.getAgent();
                Agent target = content.getTarget();//修正
                switch (content.getTopic()) {
                    case VOTE:
                        if (latestGameInfo.getAliveAgentList().contains(target)) {// vote対象が生きていないなら意味ない
                            votingMap.put(subject, target);
                        }
                        break;
                    case COMINGOUT:
                        if (target == subject) {
                            switch (content.getRole()) {
                                case WEREWOLF:
                                    if (day != 2 && !blackList.contains(target)) {
                                        blackList.add(target);
                                    }
                                default:
                                    break;
                            }
                        }
                        break;
                    case DIVINATION:
                        if (target == me && content.getResult() == Species.WEREWOLF) {
                            if (!blackList.contains(subject)) {
                                blackList.add(subject);
                            }
                        }
                    default:
                        break;
                }
            }
        }
    }

    public Judge getFakeDivination() {
        if (day == 1) {
            if (firstCandidate == null || gameTimes < 50) {
                firstCandidate = randomSelect(aliveOthers);
            }
            if (Math.random() > 0.10) {
                return new Judge(day, me, firstCandidate, Species.WEREWOLF);
            } else {
                return new Judge(day, me, firstCandidate, Species.HUMAN);
            }
        } else {
            for (Agent agent : aliveOthers) {
                if (!fakeDivinationList.contains(agent)) {
                    return new Judge(day, me, agent, Species.HUMAN);
                }
            }
        }
        return new Judge(day, me, me, Species.HUMAN);
    }

    @Override
    public void setWhiteList() {
        whiteList.clear();
        grayList.clear();

        estimateSeer = me;


        Agent candidate = me;
        for (Agent agent : SeerCOAgent) {
            if (!blackList.contains(agent) && !possessedList.contains(agent) &&
                    tf.getRoleProbability(agent, Role.SEER) != 0.0
                    && tf.getRoleProbability(agent, Role.SEER) > tf.getRoleProbability(candidate, Role.SEER)) {
                candidate = agent;
            }
        }
        if (candidate != me) {
            estimateSeer = candidate;
            for (Agent agent : humanAgentMap.get(candidate)) {
                if (blackList.contains(agent)) {
                    blackList.remove(agent);
                    possessedList.add(agent);
                }
                whiteList.add(agent);
            }
            for (Agent agent : wolfAgentMap.get(candidate)) {
                grayList.add(agent);
                if (possessedList.contains(agent)) {
                    blackList.add(agent);
                    possessedList.remove(agent);
                }
            }
        }
        return;
    }


    @Override
    public void dayStart() {
        super.dayStart();
        revoted = false;
        talkTurn = -1;
        if (day > 0) {
            Judge judge = getFakeDivination();
            if (judge != null) {
                fakeDivinationList.add(judge);
                fakeDivinationQueue.offer(judge);
                divinedAgents.add(judge.getTarget());
            }
        }
    }

    @Override
    public void considerOthersVote() {
        //被投票数をエージェントごとに取得
        HashMap<Agent, Integer> termMap = new HashMap<Agent, Integer>();
        Agent maxVoted = me;

        termMap.put(me, 0);
        for (Agent agent : werewolves) {
            if (isAlive(agent)) {
                termMap.put(agent, 0);
            }

        }

        termMap.put(voteCandidate, 0);
        for (Map.Entry<Agent, Agent> entry : votingMap.entrySet()) {
            int count = 1;
            if (termMap.containsKey(entry.getValue())) {
                count += termMap.get(entry.getValue());
            }
            if (entry.getValue() != null) {
                termMap.put(entry.getValue(), count);
            }
        }

        //現在の最大被投票者を選出
        for (Map.Entry<Agent, Integer> entry : termMap.entrySet()) {
            if (termMap.get(maxVoted) < entry.getValue()) {
                maxVoted = entry.getKey();
            }
        }

        //自分が吊られそうな場合は自分以外で最も票の多いエージェントに投票してつられないように動く
        if (maxVoted.equals(me) || werewolves.contains(maxVoted)) {
            Agent candidate = maxVoted;
            for (Map.Entry<Agent, Integer> entry : termMap.entrySet()) {
                if (termMap.get(candidate) <= entry.getValue() + 1 && me != entry.getKey()
                        && !werewolves.contains(entry.getKey())) {
                    candidate = entry.getKey();
                }
            }
            if (candidate != maxVoted) {
                voteCandidate = candidate;
            }
        }
    }

    @Override
    public Agent vote() {
        if (latestGameInfo.getAliveAgentList().size() == 3) {
            if (!revoted) {
                voteCandidate = null;
                if (isAlive(estimateSeer) && estimateSeer != me) {
                    voteCandidate = estimateSeer;
                    return voteCandidate;
                }
                for (Agent agent : latestGameInfo.getAliveAgentList()) {
                    if (!blackList.contains(agent) && agent != me && !grayList.contains(agent)) {
                        voteCandidate = agent;
                    }
                }
                if (voteCandidate == null) {
                    for (Agent agent : aliveOthers) {
                        if (!blackList.contains(agent) && (voteCandidate == null || tf.getRoleProbability(agent, Role.WEREWOLF) < tf.getRoleProbability(voteCandidate, Role.WEREWOLF))) {
                            voteCandidate = agent;
                        }
                    }
                }
                revoted = true;
            } else {
                if (isAlive(estimateSeer) && estimateSeer != me) {
                    voteCandidate = estimateSeer;
                    return voteCandidate;
                }
                for (Agent agent : aliveOthers) {
                    if (!blackList.contains(agent) && (voteCandidate == null || tf.getRoleProbability(agent, Role.WEREWOLF) < tf.getRoleProbability(voteCandidate, Role.WEREWOLF))) {
                        voteCandidate = agent;
                    }
                }
            }
            return voteCandidate;
        }

        if (!revoted) {
            canTalk = false;
            chooseVoteCandidate();
            considerOthersVote();
            revoted = true;
        } else {
            Map<Agent, Integer> voteMap = new HashMap<>();
            for (Agent agent : latestGameInfo.getAliveAgentList()) {
                voteMap.put(agent, 0);
            }
            for (Vote vote : latestGameInfo.getLatestVoteList()) {
                if (!isAlive(vote.getTarget())) {
                    continue;
                }
                int count = 1;
                count += voteMap.get(vote.getTarget());
                voteMap.put(vote.getTarget(), count);
            }

            for (Agent agent : latestGameInfo.getAliveAgentList()) {
                if (!isAlive(voteCandidate) || (voteMap.get(voteCandidate) < voteMap.get(agent) && agent != me && !werewolves.contains(agent))) {
                    voteCandidate = agent;
                }
            }
        }
        return voteCandidate;
    }

    @Override
    public void chooseVoteCandidate() {
        werewolves.clear();
        List<Agent> candidates = new ArrayList<>();

        //自分または噛まれた人に黒出しした相手は人狼と考える
        for (Judge j : divinationList) {
            if (j.getResult() == Species.WEREWOLF && (j.getTarget() == me ||
                    isKilled(j.getTarget()))) {
                if (!werewolves.contains(j.getAgent())) {
                    werewolves.add(j.getAgent());
                }
            }
        }

        int num1 = 0;
        int num2 = 0;
        Agent candidate = me;

        for (Agent agent : SeerCOAgent) {
            if (agent != me && isAlive(agent)) {
                num1 += 1;
                candidate = agent;
            } else if (agent != me && !isAlive(agent)) {
                num2 += 1;
            }
        }

        if (num1 == 1 && num2 == 1) {
            werewolves.add(candidate);
        }

        if (candidates.isEmpty()) {
            for (Agent a : aliveOthers) {
                if (!werewolves.contains(a)) {
                    candidates.add(a);
                }
            }
        }

        if (!candidates.contains(voteCandidate)) {
            voteCandidate = randomSelect(candidates);
        } else {
            voteCandidate = me;
            for (Agent agent : aliveOthers) {
                if (voteCandidate == me || tf.getRoleProbability(agent, Role.WEREWOLF) < tf.getRoleProbability(voteCandidate, Role.WEREWOLF)) {
                    voteCandidate = agent;
                }
            }
        }
    }

    @Override
    public String talk() {
        canTalk = true;
        talkTurn++;
        //残り3人になったら狂人CO
        if (latestGameInfo.getAliveAgentList().size() == 3 && talkTurn == 1) {
            talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.POSSESSED)));
        }
        if (talkTurn < 5) {
            chooseVoteCandidate();
        } else {
            considerOthersVote();
        }

        if (!isCameout && fakeRole.equals(Role.SEER)) {
            talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.SEER)));
            isCameout = true;
        }

        if (isCameout) {
            while (!fakeDivinationQueue.isEmpty()) {
                Judge divination = fakeDivinationQueue.poll();
                talkQueue.offer(
                        new Content(new DivinedResultContentBuilder(divination.getTarget(), divination.getResult())));
            }
        }

        if (voteCandidate != null && voteCandidate != declaredVoteCandidate && talkTurn > 2) {
            talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
            declaredVoteCandidate = voteCandidate;
        }

        return talkQueue.isEmpty() ? Talk.SKIP : talkQueue.poll().getText();

    }
}
