package submit.aiwolf.wordwolf;

import java.util.ArrayList;
import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class DemoSeer extends villager {
	int comingoutDay;
	boolean isCameout;
	Deque<Judge> divinationQueue = new LinkedList<>();
	Map<Agent, Species> myDivinationMap = new HashMap<>();
	List<Agent> whiteList = new ArrayList<>();
	List<Agent> blackList = new ArrayList<>();
	List<Agent> grayList;
	List<Agent> semiWolves = new ArrayList<>();
	List<Agent> possessedList = new ArrayList<>();

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		comingoutDay = 0;
		isCameout = false;
		divinationQueue.clear();
		myDivinationMap.clear();
		whiteList.clear();
		blackList.clear();
		//最初は他のエージェントは全員白
		grayList = aliveOthers;
		semiWolves.clear();
		possessedList.clear();
	}

	@Override
	public void dayStart() {
		super.dayStart();
		Judge divination = currentGameInfo.getDivineResult();
		aliveOthers=latestGameInfo.getAliveAgentList();
		if (divination != null) {
			divinationQueue.offer(divination);
			grayList.remove(divination.getTarget());
			if (divination.getResult() == Species.HUMAN) {
				whiteList.add(divination.getTarget());
			} else {
				blackList.add(divination.getTarget());
			}
			myDivinationMap.put(divination.getTarget(), divination.getResult());
		}
	}

	@Override
	public void update(GameInfo gameInfo){
		super.update(gameInfo);
	}


	@Override
	public void chooseVoteCandidate() {
		werewolves.clear();
		//自分以外の占いCOは人狼サイド
		for (Agent a : aliveOthers) {
			if (comingoutMap.get(a) == Role.SEER) {
				werewolves.add(a);
			}
		}

		//自分の占い結果と霊媒結果が一致しない霊媒師は人狼サイド
		for (Judge j : identList) {
			Agent agent = j.getAgent();
			if ((myDivinationMap.containsKey(j.getTarget())
					&& j.getResult() != myDivinationMap.get(j.getTarget()))) {
				if (isAlive(agent) && !werewolves.contains(agent)) {
					werewolves.add(agent);
					for (Role role : Role.values()) {
						if (role == Role.FOX || role == Role.FREEMASON) {
							continue;
						}
						if (role != Role.POSSESSED && role != Role.WEREWOLF) {
							tf.updateRoleProbability(agent, role, false, latestGameInfo);
						}
					}
				}
			}
		}


		//semiWolvesは人狼サイドらしきエージェントの中で狂人と確定していない人狼候補
		possessedList.clear();
		semiWolves.clear();
		for (Agent a : werewolves) {
			if (whiteList.contains(a)) {
				if (!possessedList.contains(a)) {
					possessedList.add(a);
					tf.updateRoleProbability(a, Role.POSSESSED, true, latestGameInfo);
				}
			} else {
				semiWolves.add(a);
			}
		}
		super.chooseVoteCandidate();
	}

	@Override
	public Agent vote() {
		return super.vote();
	}

	@Override
	public String talk() {
		if (!isCameout && (day >= comingoutDay || (!divinationQueue.isEmpty() &&
				divinationQueue.peekLast().getResult() == Species.WEREWOLF) ||
				isCo(Role.SEER))) {
			talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.SEER)));
			isCameout = true;
		}
		if (isCameout) {
			while (!divinationQueue.isEmpty()) {
				Judge ident = divinationQueue.poll();
				if(ident.getResult()== Species.HUMAN) {
					tf.updateRoleProbability(ident.getTarget(),Role.WEREWOLF,false, latestGameInfo);
				}else {
					tf.updateRoleProbability(ident.getTarget(), Role.WEREWOLF, true, latestGameInfo);
				}
				talkQueue.offer(new Content(new DivinedResultContentBuilder(ident.getTarget(), ident.getResult())));
			}
		}
		return super.talk();
	}

	@Override
	public Agent divine() {

		Agent candidate;
		if(day==0) {
			if(firstCandidate!=null && gameTimes >= 50) {
				return firstCandidate;
			}else{
				candidate=randomSelect(latestGameInfo.getAliveAgentList());
				return candidate;
			}
		}

		Agent divineCandidate=me;
		for(Agent agent:currentGameInfo.getAliveAgentList()){
			if(!blackList.contains(agent) && !myDivinationMap.containsKey(agent)&&
					(tf.getRoleProbability(agent, Role.WEREWOLF)>tf.getRoleProbability(divineCandidate, Role.WEREWOLF)
					|| agent == me)) {
				if(tf.getRoleProbability(agent,Role.WEREWOLF)==1.0){
					if(!blackList.contains(agent)){
						blackList.add(agent);
					}
					continue;
				}
				if (day > 3 || (comingoutMap.get(agent) != Role.SEER && comingoutMap.get(agent) != Role.MEDIUM)) {
						divineCandidate=agent;
				}
			}
		}

		return divineCandidate;
	}

	@Override
	public void setWhiteList() {
		whiteList.clear();
		grayList.clear();

		estimateMedium = me;


		for (Entry<Agent,Species> seerResult : myDivinationMap.entrySet()) {
			if(seerResult.getValue()==Species.WEREWOLF) {
				if(!blackList.contains(seerResult.getKey())) {
					blackList.add(seerResult.getKey());
				}
			}else {
				whiteList.add(seerResult.getKey());
			}
		}

		if(day>3) {
			Agent candidate = me;
			for (Agent agent : MediumCOAgent) {
				if (!blackList.contains(agent) && !possessedList.contains(agent)
						&& tf.getRoleProbability(agent, Role.MEDIUM) > tf.getRoleProbability(candidate, Role.MEDIUM)) {
					candidate = agent;
				}
			}
			if (candidate != me) {
				estimateMedium = candidate;
			}
		}
		return;
	}

	@Override
	public void addKilledAgent(Agent killedAgent) {
		super.addKilledAgent(killedAgent);
	}

	@Override
	public void addExecutedAgent(Agent executedAgent) {
		super.addExecutedAgent(executedAgent);
	}

	@Override
	public void AnalysisOfGuess(GameInfo gameInfo) {
		super.AnalysisOfGuess(gameInfo);
	}


	//votingMap(投票予定先)の更新

	@Override
	public void setVoteMap(List<Talk> talkList) {
		super.setVoteMap(talkList);
	}

	@Override
	public void setCOPlus(List<Talk> talkList) {
		super.setCOPlus(talkList);
	}

	@Override
	void considerVote(List<Agent> majorityList) {
		super.considerVote(majorityList);
	}

	@Override
	public void considerOthersVote() {
		super.considerOthersVote();
	}

}
