package submit.aiwolf.wordwolf;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import java.util.*;
import java.util.Map.Entry;

public class DemoSeer5 extends villager5 {
    int comingoutDay;
    boolean isCameout;
    Deque<Judge> divinationQueue = new LinkedList<>();
    Map<Agent, Species> myDivinationMap = new HashMap<>();
    List<Agent> whiteList = new ArrayList<>();
    List<Agent> blackList = new ArrayList<>();
    List<Agent> grayList;
    List<Agent> semiWolves = new ArrayList<>();
    List<Agent> possessedList = new ArrayList<>();

    @Override
    public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
        super.initialize(gameInfo, gameSetting);
        comingoutDay = 0;
        isCameout = false;
        divinationQueue.clear();
        myDivinationMap.clear();
        whiteList.clear();
        blackList.clear();
        //最初は他のエージェントは全員白
        grayList = aliveOthers;
        semiWolves.clear();
        possessedList.clear();
    }

    @Override
    public void dayStart() {
        super.dayStart();
        Judge divination = currentGameInfo.getDivineResult();
        aliveOthers = latestGameInfo.getAliveAgentList();
        if (divination != null) {
            divinationQueue.offer(divination);
            grayList.remove(divination.getTarget());
            if (divination.getResult() == Species.HUMAN) {
                whiteList.add(divination.getTarget());
            } else {
                blackList.add(divination.getTarget());
            }
            myDivinationMap.put(divination.getTarget(), divination.getResult());
        }
    }

    @Override
    public void update(GameInfo gameInfo) {
        super.update(gameInfo);
    }


    @Override
    public void chooseVoteCandidate() {
        werewolves.clear();
        //自分以外の占いCOは人狼サイド
        for (Agent a : aliveOthers) {
            if (comingoutMap.get(a) == Role.SEER) {
                werewolves.add(a);
            }
        }

        if (!blackList.isEmpty()) {
            chooseWerewolf(blackList);
            return;
        }

        if (werewolves.isEmpty()) {
            for (Agent agent : aliveOthers) {
                if (isAlive(agent) && tf.getRoleProbability(agent, Role.WEREWOLF) > 0.3) {
                    werewolves.add(agent);
                }
            }
        }

        if (estimateSeer != me && !grayList.isEmpty()) {
            chooseWerewolf(grayList);
            return;
        }

        if (werewolves.isEmpty()) {
            List<Agent> candidates = aliveOthers;
            candidates.removeAll(whiteList);
            if (!candidates.contains(voteCandidate)) {
                chooseWerewolf(aliveOthers);
            }
        } else {
            if (!werewolves.contains(voteCandidate)) {
                chooseWerewolf(werewolves);
            }
        }
    }

    @Override
    public Agent vote() {

        if (!blackList.isEmpty()) {
            return blackList.get(0);
        } else {
            voteCandidate=me;
            for (Agent agent : aliveOthers) {
                if (tf.getRoleProbability(voteCandidate, Role.WEREWOLF) < tf.getRoleProbability(agent, Role.WEREWOLF)) {
                    voteCandidate = agent;
                }
            }
        }

        if(day==2){
            for(Agent agent:aliveOthers){
                if(whiteList.contains(agent)){
                    for(Agent wolf:aliveOthers){
                        if(agent!=wolf){
                            voteCandidate=wolf;
                            return voteCandidate;
                        }
                    }
                }
            }
        }
        return voteCandidate;


    }

    @Override
    public String talk() {
        if (!isCameout && (day >= comingoutDay || (!divinationQueue.isEmpty() &&
                divinationQueue.peekLast().getResult() == Species.WEREWOLF) ||
                isCo(Role.SEER))) {
            talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.SEER)));
            isCameout = true;
        }
        if (isCameout) {
            while (!divinationQueue.isEmpty()) {
                Judge ident = divinationQueue.poll();
                if (ident.getResult() == Species.HUMAN) {
                    tf.updateRoleProbability(ident.getTarget(), Role.WEREWOLF, false, latestGameInfo);
                } else {
                    tf.updateRoleProbability(ident.getTarget(), Role.WEREWOLF, true, latestGameInfo);
                }
                talkQueue.offer(new Content(new DivinedResultContentBuilder(ident.getTarget(), ident.getResult())));
            }
        }
        return super.talk();
    }

    @Override
    public Agent divine() {

        Agent candidate;
        if (day == 0) {
            candidate = randomSelect(latestGameInfo.getAliveAgentList());
            return candidate;
        }

        Agent divineCandidate = me;
        for (Agent agent : currentGameInfo.getAliveAgentList()) {
            if (!blackList.contains(agent) && !myDivinationMap.containsKey(agent) &&
                    (tf.getRoleProbability(agent, Role.WEREWOLF) > tf.getRoleProbability(divineCandidate, Role.WEREWOLF)
                            || agent == me)) {
                if (tf.getRoleProbability(agent, Role.WEREWOLF) == 1.0) {
                    if (!blackList.contains(agent)) {
                        blackList.add(agent);
                    }
                }
                divineCandidate = agent;
            }
        }

        return divineCandidate;
    }

    @Override
    public void setWhiteList() {
        whiteList.clear();
        grayList.clear();

        estimateMedium = me;


        for (Entry<Agent, Species> seerResult : myDivinationMap.entrySet()) {
            if (seerResult.getValue() == Species.WEREWOLF) {
                if (!blackList.contains(seerResult.getKey())) {
                    blackList.add(seerResult.getKey());
                }
            } else {
                whiteList.add(seerResult.getKey());
            }
        }

        for (Agent fakeSeer : SeerCOAgent) {
            if (fakeSeer == me) {
                continue;
            }

            if (!blackList.contains(fakeSeer) && !blackList.isEmpty()) {
                possessedList.add(fakeSeer);
                if (whiteList.contains(fakeSeer)) {
                    whiteList.remove(fakeSeer);
                }
            } else if (!possessedList.contains(fakeSeer) && !possessedList.isEmpty()) {
                blackList.add(fakeSeer);
            }
        }

        return;
    }

    @Override
    public void addKilledAgent(Agent killedAgent) {
        super.addKilledAgent(killedAgent);
    }

    @Override
    public void addExecutedAgent(Agent executedAgent) {
        super.addExecutedAgent(executedAgent);
    }

    @Override
    public void AnalysisOfGuess(GameInfo gameInfo) {
        super.AnalysisOfGuess(gameInfo);
    }


    //votingMap(投票予定先)の更新

    @Override
    public void setVoteMap(List<Talk> talkList) {
        super.setVoteMap(talkList);
    }

    @Override
    public void setCOPlus(List<Talk> talkList) {
        super.setCOPlus(talkList);
    }


    @Override
    public void considerOthersVote() {
        super.considerOthersVote();
    }

}
