package submit.aiwolf.wordwolf;

import org.aiwolf.client.lib.*;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import java.util.*;

public class DemoWerewolf5 extends DemoBasePlayer5 {
    //もっと生存率を上げたい
    //占い師への投票率が高め
    //役職持ちへの投票は中盤以降にすべきでは？
    int numWolves;
    Role fakeRole;
    int comingoutDay;
    int comingoutTurn;
    boolean isCameout;
    boolean whisperCameout;
    int guardedDay = -1;

    Map<Agent, Species> fakeJudgeMap = new HashMap<>();
    Deque<Judge> fakeJudgeQueue = new LinkedList<>();
    List<Agent> possessedList = new ArrayList<>();
    List<Agent> werewolves;
    List<Agent> humans;
    List<Agent> villagers;
    List<Agent> bodyguardList = new ArrayList<>();
    HashMap<Agent, Integer> termTodaysVoteMap = new HashMap<>();
    int talkTurn;
    List<Map<Agent, Agent>> votingMapHistory = new ArrayList<>();
    // 投票予定map
    Map<Agent, Agent> votingMap;
    //襲撃予定map
    Map<Agent, Agent> attackVotingMap;
    //騙り役職map
    Map<Agent, Role> fakeRoleMap;
    //ゲーム情報
    public GameInfo latestGameInfo;
    // その日のログの何番目まで読み込んだか
    int readTalkNum;
    int readWhisperNum;
    boolean voteLock = false;
    List<Agent> blackList = new ArrayList<>();
    int vilFakeNum = 80;
    int serFakeNum = 95;
    int whisperturn = -1;
    boolean revoted = false;
    double randomSeed = 0.0;
    double randomSeed2 = 0.0;
    double randomSeed3 = 0.0;
    double randomSeed4 = 0.0;
    List<Agent> guardedAgent = new ArrayList<>();

    @Override
    public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
        super.initialize(gameInfo, gameSetting);
        comingoutMap = new HashMap<>();
        fakeRoleMap = new HashMap<>();
        numWolves = gameSetting.getRoleNumMap().get(Role.WEREWOLF);
        werewolves = new ArrayList<>(gameInfo.getRoleMap().keySet());
        votingMapHistory = new ArrayList<>();
        humans = new ArrayList<>();
        villagers = new ArrayList<>();
        guardedAgent = new ArrayList<>();
        whisperCameout = false;
        guardedDay = -1;

        for (Agent a : aliveOthers) {
            if (!werewolves.contains(a)) {
                humans.add(a);
            }
        }


        List<Role> roles = new ArrayList<>();
        for (Role r : Arrays.asList(Role.VILLAGER, Role.SEER, Role.POSSESSED, Role.WEREWOLF)) {
            if (gameInfo.getExistingRoles().contains(r)) {
                roles.add(r);
            }
        }

        bodyguardList = new ArrayList<>();
        // カミングアウトしているプレイヤーのリスト
        SeerCOAgent = new HashSet<>();
        MediumCOAgent = new HashSet<>();
        // 占い師COエージェントごとの人狼・人間判定
        wolfAgentMap = new HashMap<>();
        humanAgentMap = new HashMap<>();
        wolfAgentMapByMedium = new HashMap<>();
        humanAgentMapByMedium = new HashMap<>();
        // 占い師、霊媒師COした順番
        orderSeerCO = new HashMap<>();
        orderMediumCO = new HashMap<>();
        // その日のログの何番目まで読み込んだか
        readTalkNum = 0;
        readWhisperNum = 0;

        latestGameInfo = gameInfo;
        blackList = new ArrayList<>();
        fakeRole = null;
        selectFakeRole();
        comingoutDay = 1;
        comingoutTurn = 0;
        isCameout = false;
        fakeJudgeMap.clear();
        fakeJudgeQueue.clear();
        possessedList.clear();
        // 投票予定map
        votingMap = new HashMap<>();
        // その日のログの何番目まで読み込んだか
        readTalkNum = 0;
        termTodaysVoteMap = new HashMap<>();
        attackVotingMap = new HashMap<>();
        fakeRoleMap = new HashMap<>();
        voteLock = false;
        infoMap = new HashMap<>();
    }

    private void selectFakeRole() {
        int tmp = (int) (Math.random() * 100);
        if (tmp < vilFakeNum) {
            fakeRole = Role.VILLAGER;
        } else {
            fakeRole = Role.SEER;
        }
    }

    @Override
    public void update(GameInfo gameInfo) {
        super.update(gameInfo);
        // 計測したい処理を記述
        latestGameInfo = gameInfo;
        // 今日のログを取得
        List<Talk> talkList = latestGameInfo.getTalkList();
        List<Talk> whisperList = latestGameInfo.getWhisperList();
        try {
            setFakeRoleMap(whisperList);


            for (Judge j : divinationList) {
                Agent agent = j.getAgent();
                if (!werewolves.contains(agent)
                        && ((humans.contains(j.getTarget()) && j.getResult() == Species.WEREWOLF)
                        || (werewolves.contains(j.getTarget()) && j.getResult() == Species.HUMAN))) {
                    if (!possessedList.contains(agent)) {
                        possessedList.add(agent);
                    }
                }
            }
            villagers.clear();
            for (Agent agent : aliveOthers) {
                if (!werewolves.contains(agent) && !possessedList.contains(agent)) {
                    villagers.add(agent);
                }
            }

            // readTalkNumの更新
            readTalkNum = talkList.size();
            readWhisperNum = whisperList.size();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void setFakeRoleMap(List<Talk> whisperList) {
        if (latestGameInfo.getAliveAgentList().contains(
                latestGameInfo.getAgent())) {
            for (int i = readWhisperNum; i < whisperList.size(); i++) {
                Talk talk = whisperList.get(i);
                // 発話をパース
                Content content = new Content(talk.getText());//修正

                Agent subject = talk.getAgent();
                Agent target = content.getTarget();//修正
                switch (content.getTopic()) {
                    case ATTACK:
                        if (latestGameInfo.getAliveAgentList().contains(target)) {// vote対象が生きていないなら意味ない
                            attackVotingMap.put(subject, target);
                        }
                        break;
                    case COMINGOUT:
                        fakeRoleMap.put(subject, content.getRole());
                        break;
                    default:
                        break;
                }
            }
        }

    }


    void considerOthersVote() {
        //被投票数をエージェントごとに取得
        termTodaysVoteMap.clear();

        Agent maxVoted = me;

        for (Agent agent : latestGameInfo.getAliveAgentList()) {
            if (isAlive(agent)) {
                termTodaysVoteMap.put(agent, 0);
            }
        }

        termTodaysVoteMap.put(voteCandidate, 0);
        for (Map.Entry<Agent, Agent> entry : votingMap.entrySet()) {
            int count = 1;
            if (entry.getValue() != null && entry.getKey() != null && termTodaysVoteMap.containsKey(entry.getValue())) {
                count += termTodaysVoteMap.get(entry.getValue());
                if (entry.getValue() != null) {
                    termTodaysVoteMap.put(entry.getValue(), count);
                }
            }
        }

        //現在の最大被投票者を選出
        for (Map.Entry<Agent, Integer> entry : termTodaysVoteMap.entrySet()) {
            if (termTodaysVoteMap.get(maxVoted).intValue() < entry.getValue().intValue()) {
                maxVoted = entry.getKey();
            }
        }

        Agent candidate = maxVoted;
        List<Agent> candidates = new ArrayList<>();

        //PPが狙えそうであれば狙いに行く
        if (checkPP()) {
            int num = 0;
            for (Map.Entry<Agent, Integer> entry : termTodaysVoteMap.entrySet()) {
                if (entry.getKey() != null && num < entry.getValue()
                        && !werewolves.contains(entry.getKey()) && !blackList.contains(entry.getKey())) {
                    candidate = entry.getKey();
                    num = entry.getValue();
                }
            }
            if (candidate != maxVoted) {
                voteCandidate = candidate;
                return;
            }

        }

        //人狼が吊られそうでかつ、自分の票の移動で吊り逃れが出来そうな場合は票を動かす
        if (werewolves.contains(maxVoted) && !blackList.contains(maxVoted)) {
            for (Map.Entry<Agent, Integer> entry : termTodaysVoteMap.entrySet()) {
                if (entry.getKey() != null && termTodaysVoteMap.get(candidate) <= entry.getValue() + 1
                        && !werewolves.contains(entry.getKey()) && !blackList.contains(entry.getKey())) {
                    candidates.add(entry.getKey());
                }
            }
            if (!candidates.isEmpty()) {
                candidate = candidates.get(0);
                for (Agent agent : candidates) {
                    if (tf.getRoleProbability(agent, Role.POSSESSED) < tf.getRoleProbability(candidate, Role.POSSESSED)) {
                        candidate = agent;
                    }
                }
            }
            if (candidate != maxVoted) {
                voteCandidate = candidate;
            }
        }

    }

    void considerVote() {
        //被投票数をエージェントごとに取得
        HashMap<Agent, Integer> termHistoryMap = new HashMap<>();
        for (Agent agent : latestGameInfo.getAliveAgentList()) {
            termHistoryMap.put(agent, 0);
        }

        for (Map.Entry<Agent, Agent> voting : votingMap.entrySet()) {
            if (voting.getValue() == null) {
                continue;
            }
            int count = 1;
            if (isAlive(voting.getValue())) {
                count += termHistoryMap.get(voting.getValue());
                termHistoryMap.put(voting.getValue(), count);
            }
        }

        boolean flag = false;
        //最も票を入れられたエージェントに投票する
        for (Agent agent : aliveOthers) {
            if ((werewolves.contains(agent) && !blackList.contains(agent)) ||
                    tf.getRoleProbability(agent, Role.POSSESSED) > 0.3) {
                continue;
            }
            if (!flag) {
                flag = true;
                voteCandidate = agent;
                continue;
            } else if (termHistoryMap.get(agent) > termHistoryMap.get(voteCandidate)) {
                voteCandidate = agent;
            }
        }
    }

    public boolean checkPP() {
        int num = 0;
        for (Agent agent : werewolves) {
            if (isAlive(agent)) {
                num += 1;
            }
        }
        if (!possessedList.isEmpty()) {
            if ((isAlive(possessedList.get(0)))) {
                num += 1;
            }
        }
        if (num * 2 >= latestGameInfo.getAliveAgentList().size()) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public Agent vote() {
        if (latestGameInfo.getAliveAgentList().size() == 3) {
            if (!revoted) {
                voteCandidate = null;
                for (Agent agent : latestGameInfo.getAliveAgentList()) {
                    if (!possessedList.contains(agent) && agent != me) {
                        voteCandidate = agent;
                    }
                }
                if (voteCandidate == null) {
                    voteCandidate = randomSelect(latestGameInfo.getAliveAgentList());
                }
                revoted = true;
            } else {
                for (Agent agent : aliveOthers) {
                    if (agent != voteCandidate) {
                        voteCandidate = agent;
                        break;
                    }
                }
            }
            return voteCandidate;
        }

        if (!revoted) {
            canTalk = false;
            int aliveWolves = 0;
            for (Agent agent : werewolves) {
                if (isAlive(agent)) {
                    aliveWolves += 1;
                }
            }

            considerOthersVote();

            //被投票数をエージェントごとに取得
            HashMap<Agent, Integer> termMap = new HashMap<>();
            Agent maxVoted = me;

            termMap.put(me, 0);
            for (Agent agent : werewolves) {
                if (isAlive(agent)) {
                    termMap.put(agent, 0);
                }

            }

            termMap.put(voteCandidate, 0);
            for (Map.Entry<Agent, Agent> entry : votingMap.entrySet()) {
                int count = 1;
                if (termMap.containsKey(entry.getValue())) {
                    count += termMap.get(entry.getValue());
                }
                if (entry.getValue() != null) {
                    termMap.put(entry.getValue(), count);
                }
            }

            //現在の最大被投票者を選出
            for (Map.Entry<Agent, Integer> entry : termMap.entrySet()) {
                if (termMap.get(maxVoted) < entry.getValue()) {
                    maxVoted = entry.getKey();
                }
            }

            //自分が吊られそうな場合は自分以外で最も票の多いエージェントに投票してつられないように動く
            if (maxVoted.equals(me)) {
                Agent candidate = maxVoted;
                for (Map.Entry<Agent, Integer> entry : termMap.entrySet()) {
                    if (termMap.get(candidate) <= entry.getValue() + 1 && me != entry.getKey()) {
                        candidate = entry.getKey();
                    }
                }
                if (candidate != maxVoted) {
                    voteCandidate = candidate;
                }
            }
            if (termMap.get(maxVoted) > aliveWolves * 2 && termMap.get(voteCandidate) + 1 < termMap.get(maxVoted) && maxVoted != me) {
                voteCandidate = maxVoted;
            }
            revoted = true;
        } else {
            Map<Agent, Integer> voteMap = new HashMap<>();
            for (Agent agent : latestGameInfo.getAliveAgentList()) {
                voteMap.put(agent, 0);
            }
            for (Vote vote : latestGameInfo.getLatestVoteList()) {
                if (!isAlive(vote.getTarget())) {
                    continue;
                }
                int count = 1;
                count += voteMap.get(vote.getTarget());
                voteMap.put(vote.getTarget(), count);
            }

            for (Agent agent : latestGameInfo.getAliveAgentList()) {
                if (!isAlive(voteCandidate)
                        || (voteMap.get(voteCandidate) < voteMap.get(agent) && !agent.equals(me))) {
                    voteCandidate = agent;
                }
            }
        }

        return voteCandidate;
    }

    private Judge getFakeJudge() {
        Agent target = null;

        if (fakeRole == Role.SEER) {
            List<Agent> candidates = new ArrayList<>();

            if (day == 1) {
                if (firstCandidate == null || gameTimes < 50) {
                    firstCandidate=randomSelect(aliveOthers);
                }
                if (Math.random() > 0.10) {
                    return new Judge(day, me, firstCandidate, Species.WEREWOLF);
                } else {
                    return new Judge(day, me, firstCandidate, Species.HUMAN);
                }
            }

            for (Agent a : aliveOthers) {
                if (!fakeJudgeMap.containsKey(a)) {
                    candidates.add(a);
                }
            }
            if (candidates.isEmpty()) {
                target = randomSelect(aliveOthers);
            } else {
                target = randomSelect(candidates);
            }
        } else if (fakeRole == Role.MEDIUM) {
            target = currentGameInfo.getExecutedAgent();
        }
        if (target != null) {
            Species result = Species.HUMAN;
            int nFakeWolves = 0;
            int aliveNum = 0;
            for (Agent a : fakeJudgeMap.keySet()) {
                if (fakeJudgeMap.get(a) == Species.WEREWOLF) {
                    nFakeWolves++;
                }
                if(isAlive(a) && latestGameInfo.getAttackedAgent() != target){
                    aliveNum++;
                }
            }
            if ((fakeRole == Role.SEER && nFakeWolves < numWolves)) {
                if (possessedList.contains(target)) {
                    double correction = relianceList.get(target) / 300.0;
                    if (Math.random() < 0.50 - correction|| aliveNum == 1) {
                        result = Species.WEREWOLF;
                    }
                } else {
                    result = Species.WEREWOLF;
                }
            }
            if (latestGameInfo.getAttackedAgent() == target) {
                result = Species.HUMAN;
            }
            return new Judge(day, me, target, result);
        }
        return null;
    }

    @Override
    public void dayStart() {
        super.dayStart();
        whisperturn = -1;
        talkTurn = -1;
        voteLock = false;
        revoted = false;
        randomSeed = Math.random();
        randomSeed2 = Math.random();
        randomSeed3 = Math.random();
        randomSeed4 = Math.random();

        if (day > 0) {
            Judge judge = getFakeJudge();
            if (judge != null) {
                fakeJudgeQueue.offer(judge);
                fakeJudgeMap.put(judge.getTarget(), judge.getResult());
            }
        }

        for (Agent agent : latestGameInfo.getAgentList()) {
            EstimateTime.put(agent, 0);
        }

        attackVoteCandidate = null;
        attackVotingMap = new HashMap<>();


    }

    @Override
    public void chooseVoteCandidate() {
        List<Agent> divinedWerewolves = new ArrayList<>();

        for (Judge j : divinationList) {
            if (j.getResult() == Species.WEREWOLF) {
                if ((j.getTarget() == me || isKilled(j.getTarget()))) {
                    Agent candidate = j.getAgent();
                    if (!blackList.contains(candidate)) {
                        blackList.add(candidate);
                    }
                } else if ((day >= 2 || !isCo(j.getTarget())) && isAlive(j.getTarget()) && j.getTarget() != me && !blackList.contains(j.getAgent())) {
                    divinedWerewolves.add(j.getTarget());
                }
            }
        }

        if (!divinedWerewolves.isEmpty()) {
            voteCandidate = randomSelect(divinedWerewolves);
        } else {
            considerVote();
        }
    }

    @Override
    public String talk() {
        canTalk = true;
        talkTurn++;
        chooseVoteCandidate();

        if (fakeRole != Role.VILLAGER) {
            if (isCameout) {
                int fakeSeerCo = 0;
                int fakeMediumCo = 0;
                for (Agent a : werewolves) {
                    if (comingoutMap.get(a) == Role.SEER || fakeRoleMap.get(a) == Role.SEER) {
                        fakeSeerCo++;
                    } else if (comingoutMap.get(a) == Role.MEDIUM || fakeRoleMap.get(a) == Role.MEDIUM) {
                        fakeMediumCo++;
                    }
                }
                if (fakeRole == Role.SEER && fakeSeerCo > 0 || fakeRole == Role.MEDIUM && fakeMediumCo > 0) {
                    fakeRole = Role.VILLAGER;
                } else {
                    for (Agent a : humans) {
                        if (comingoutMap.get(a) == fakeRole) {
                            comingoutDay = day;
                        }
                    }
                    if (day >= comingoutDay && talkTurn >= comingoutTurn) {
                        isCameout = true;
                        talkQueue.offer(new Content(new ComingoutContentBuilder(me, fakeRole)));
                    }
                }
            } else {
                while (!fakeJudgeQueue.isEmpty()) {
                    Judge judge = fakeJudgeQueue.poll();
                    if (fakeRole == Role.SEER) {
                        talkQueue.offer(new Content(new DivinedResultContentBuilder(judge.getTarget(),
                                judge.getResult())));
                    } else if (fakeRole == Role.MEDIUM) {
                        talkQueue.offer(new Content(new IdentContentBuilder(judge.getTarget(), judge.getResult())));
                    }
                }
            }
        }

        return super.talk();
    }

    @Override
    public String whisper() {
        whisperturn += 1;
        if (whisperturn == 0 && day > 0) {
            Map<Agent, Agent> temp = new HashMap<>();
            for (Vote vote : latestGameInfo.getVoteList()) {
                temp.put(vote.getAgent(), vote.getTarget());
            }
            votingMapHistory.add(temp);
        }


        for (Agent agent : possessedList) {
            whisperQueue.offer(new Content(new EstimateContentBuilder(agent, Role.POSSESSED)));
        }

        if (day == 0 && !whisperCameout) {
            whisperCameout = true;
            whisperQueue.offer(new Content(new ComingoutContentBuilder(me, fakeRole)));
        }

        chooseAttackVoteCandidate();
        if (attackVoteCandidate != null && attackVoteCandidate != declaredAttackVoteCandidate
                && day != 0) {
            whisperQueue.offer(new Content(new AttackContentBuilder(attackVoteCandidate)));
            declaredAttackVoteCandidate = attackVoteCandidate;
        }
        if (declaredAttackVoteCandidate != null) {
            whisperQueue.offer(new Content(new RequestContentBuilder(null,
                    new Content(new AttackContentBuilder(declaredAttackVoteCandidate)))));
        }
        return whisperQueue.isEmpty() ? Talk.SKIP : whisperQueue.poll().getText();
    }

    @Override
    public void chooseAttackVoteCandidate() {

        if (attackVoteCandidate != null) {
            return;
        }

        List<Agent> candidates = new ArrayList<>();

        if (randomSeed2 < 0.5 && !isAlive(latestGameInfo.getAttackedAgent())) {
            considerAttackVillagersVote();
        } else {
            boolean searchBG = false;
            attackVoteCandidate = searchBodyguard(searchBG);
        }

        if (attackVoteCandidate != null) {
            return;
        }

        if (candidates.isEmpty()) {
            for (Agent agent : villagers) {
                if (isAlive(agent)) {
                    candidates.add(agent);
                }
            }
        }

        if (candidates.isEmpty()) {
            for (Agent agent : possessedList) {
                if (isAlive(agent)) {
                    candidates.add(agent);
                }
            }
        }

        if (!candidates.isEmpty()) {
            attackVoteCandidate = randomSelect(candidates);
            for (Agent agent : candidates) {
                if (!isCo(agent) && tf.getRoleProbability(attackVoteCandidate, Role.POSSESSED) > tf.getRoleProbability(agent,
                        Role.POSSESSED)) {
                    attackVoteCandidate = agent;
                }
            }
        }
    }

    public Agent searchBodyguard(boolean seracBG) {
        Agent candidate = null;
        List<Agent> candidates = new ArrayList<>();
        for (Agent agent : aliveOthers) {
            if (agent == null || (randomSeed4 > 0.5 && possessedList.contains(agent)) || werewolves.contains(agent)) {
                continue;
            }
            candidates.add(agent);
        }

        double tmp = 0.0;
        Agent bodyGuardCandidate = me;
        if (seracBG) {
            for (Agent agent : candidates) {
                double tmp2 = tf.getRoleProbability(agent, Role.BODYGUARD);
                if (tmp < tmp2) {
                    tmp = tmp2;
                    bodyGuardCandidate = agent;
                }
            }
            if (bodyGuardCandidate != me) {
                return bodyGuardCandidate;
            }
        }

        //人狼への過去の投票数をエージェントごとに取得
        HashMap<Agent, Integer> termHistoryMap = new HashMap<>();
        for (Agent agent : candidates) {
            if (isAlive(agent)) {
                termHistoryMap.put(agent, 0);
            }
        }

        int i = 0;
        //グレーの中から人狼への過去の投票回数のカウント
        for (Map<Agent, Agent> votingHistory : votingMapHistory) {
            for (Agent agent : candidates) {
                int count = 1;
                if (werewolves.contains(votingHistory.get(agent)) && isAlive(votingHistory.get(agent))) {
                    count += termHistoryMap.get(agent);
                    termHistoryMap.put(agent, count);
                }
            }
        }

        boolean flag = false;

        for (Agent agent : candidates) {
            if (!flag) {
                flag = true;
                candidate = agent;
            } else {
                if (termHistoryMap.get(agent) > termHistoryMap.get(candidate)) {
                    candidate = agent;
                }
            }
        }

        return candidate;
    }


    void considerAttackVillagersVote() {
        //人狼への過去の投票数をエージェントごとに取得
        HashMap<Agent, Integer> termHistoryMap = new HashMap<>();
        for (Agent agent : villagers) {
            if (isAlive(agent)) {
                termHistoryMap.put(agent, 0);
            }
        }

        //グレーの中から人狼への過去の投票回数のカウント
        for (Map<Agent, Agent> votingHistory : votingMapHistory) {
            for (Agent agent : villagers) {
                int count = 1;
                if (werewolves.contains(votingHistory.get(agent)) && isAlive(votingHistory.get(agent))) {
                    count += termHistoryMap.get(agent);
                    termHistoryMap.put(agent, count);
                }
            }
        }

        //最も白に見られているエージェントを噛む
        int temp = 0;
        boolean flag = false;
        for (Agent agent : villagers) {
            if (!flag && isAlive(agent) && (randomSeed4 > 0.5 || !isCo(agent))) {
                flag = true;
                temp = relianceList.get(agent);
                attackVoteCandidate = agent;
                continue;
            }
            if ((randomSeed4 > 0.5 || !isCo(agent)) && isAlive(agent) && temp < relianceList.get(agent)) {
                temp = relianceList.get(agent);
                attackVoteCandidate = agent;
            }
        }
    }

    @Override
    public Agent attack() {
        return super.attack();
    }

    @Override
    public void addKilledAgent(Agent killedAgent) {
        super.addKilledAgent(killedAgent);
    }

    @Override
    public void addExecutedAgent(Agent executedAgent) {
        super.addExecutedAgent(executedAgent);
    }

    @Override
    public void AnalysisOfGuess(GameInfo gameInfo) {
        super.AnalysisOfGuess(gameInfo);
        fakeResult.Guess(gameInfo, gameTimes, fakeRole, true);
    }
}
