package submit.aiwolf.wordwolf;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;

import java.util.HashMap;

public class FakeResult {
    private static FakeResult instance= new FakeResult();

    private FakeResult() {
        // 最初はインスタンスを生成しない
        instance=null;
    }

    public static FakeResult getInstance() {
        // メソッド呼び出しがあったときに、
        // 初めてインスタンスを生成
        if (instance == null) {
            instance = new FakeResult();
        }
        return instance;
    }

    HashMap<Role,Integer> fakeTime=new HashMap<>();
    HashMap<Role,Integer> fakeResult=new HashMap<>();

    public void Guess(GameInfo gameInfo,int gameTimes,Role fakeRole,boolean isWolf) {
        boolean result=false;
        if(fakeTime.isEmpty()||fakeResult.isEmpty()){
            fakeResult.put(Role.SEER,0);
            fakeResult.put(Role.VILLAGER,0);
            fakeTime.put(Role.SEER,0);
            fakeTime.put(Role.VILLAGER,0);
        }

        if(!isWolf){
            if(gameTimes==1000){
                System.out.println("村人:"+fakeResult.get(Role.VILLAGER)+"/"+fakeTime.get(Role.VILLAGER));
                System.out.println("占い師:"+fakeResult.get(Role.SEER)+"/"+fakeTime.get(Role.SEER));
            }
            return;
        }

        int tmp= fakeTime.get(fakeRole);
        fakeTime.put(fakeRole,tmp+1);

        for(Agent agent:gameInfo.getAliveAgentList()){
            if(gameInfo.getRoleMap().get(agent)==Role.WEREWOLF){
                result=true;
                break;
            }
        }
        if(result){
            tmp= fakeResult.get(fakeRole);
            fakeResult.put(fakeRole,tmp+1);
        }

        if(gameTimes==1000){
            System.out.println("村人:"+fakeResult.get(Role.VILLAGER)+"/"+fakeTime.get(Role.VILLAGER));
            System.out.println("占い師:"+fakeResult.get(Role.SEER)+"/"+fakeTime.get(Role.SEER));
        }

    }
}
