package submit.aiwolf.wordwolf;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class villager5 extends DemoBasePlayer5 {

    //役職持ちはじっくり見ていったほうがよさげ
    //人狼への投票精度が最もおおきな勝率要因となっている
    //役職持ちへの投票率をへらしたい
    List<Agent> blackList = new ArrayList<>();
    List<Agent> deadList = new ArrayList<>();
    List<Agent> possessedList = new ArrayList<>();
    List<Agent> bodyguardList = new ArrayList<>();
    List<Map<Agent, Agent>> votingMapHistory = new ArrayList<>();
    boolean revoted = false;
    //占い師に白だしされたエージェントのリスト
    List<Agent> whiteList = new ArrayList<>();
    List<Agent> grayList = new ArrayList<>();
    double randomseed3 = 0.0;
    Agent estimateSeer = me;
    Agent estimateMedium = me;

    @Override
    public void dayStart() {
        super.dayStart();
        deadList.addAll(latestGameInfo.getLastDeadAgentList());
        revoted = false;
        // 初期化
        readTalkNum = 0;
        randomseed3 = Math.random();
        votingMap = new HashMap<>();
        for (Agent agt : latestGameInfo.getAliveAgentList()) {
            votingMap.put(agt, null);
        }
        whiteList = new ArrayList<>();
    }

    @Override
    public String getName() {

        return getName();
    }

    @Override
    public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
        super.initialize(gameInfo, gameSetting);

        // 投票予定map
        votingMap = new HashMap<>();
        votingMapHistory = new ArrayList<>();
        // その日のログの何番目まで読み込んだか
        readTalkNum = 0;
        deadList = new ArrayList<>();
        possessedList = new ArrayList<>();
        bodyguardList = new ArrayList<>();
        grayList = new ArrayList<>();
        tf.startGame(gameInfo, gameSetting);
        allRole.clear();
        relianceList = new HashMap<>();

        for (Role role : gameSetting.getRoleNumMap().keySet()) {
            if (role != Role.FOX && role != Role.FREEMASON&& role != Role.MEDIUM && role != Role.BODYGUARD) {
                allRole.add(role);
            }
        }

        latestGameInfo = gameInfo;
        blackList = new ArrayList<>();
        estimateSeer = me;
        estimateMedium = me;
    }

    @Override
    public String talk() {
        canTalk = true;
        turn += 1;
        chooseVoteCandidate();
        //1日の序盤のターンは自分の人狼と思う候補に投票宣言
        if (turn > 3) {
            considerOthersVote();
        }


        //残り3人の時に狂人がいると考えられる場合は人狼を騙る
        if (currentGameInfo.getAliveAgentList().size() == 3 && !isCo(me)) {
            boolean check = false;

            for (Agent agent : possessedList) {
                if (isAlive(agent)) {
                    talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.WEREWOLF)));
                    check = true;
                    break;
                }
            }
            if (check) {
                int blackListAlive = 0;
                for (Agent agent : blackList) {
                    if (isAlive(agent)) {
                        blackListAlive++;
                        break;
                    }
                }

                if (blackListAlive >= 2) {
                    talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.WEREWOLF)));
                    return talkQueue.isEmpty() ? Talk.SKIP : talkQueue.poll().getText();
                }
            }
        }

        if (voteCandidate != null && voteCandidate != declaredVoteCandidate) {
            talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
            declaredVoteCandidate = voteCandidate;
        }

        return talkQueue.isEmpty() ? Talk.SKIP : talkQueue.poll().getText();
    }

    @Override
    public void update(GameInfo gameInfo) {
        // 計測したい処理を記述
        latestGameInfo = gameInfo;
        super.update(gameInfo);
        //System.out.println("update is called.\n");
        // 今日のログを取得
        List<Talk> talkList = latestGameInfo.getTalkList();
        // voting,votedMapの更新
        setVoteMap(talkList);
        // 各エージェントのCOの更新
        setCOPlus(talkList);
        // readTalkNumの更新
        readTalkNum = talkList.size();

        setWhiteList();

        if (!possessedList.isEmpty() && !blackList.isEmpty()) {
            blackList.removeAll(possessedList);
        }

    }

    public void setWhiteList() {
        whiteList.clear();
        grayList.clear();

        estimateSeer = me;


        Agent candidate = me;
        for (Agent agent : SeerCOAgent) {
            if (!blackList.contains(agent) && !possessedList.contains(agent) &&
                    tf.getRoleProbability(agent, Role.SEER) != 0.0
                    && tf.getRoleProbability(agent, Role.SEER) > tf.getRoleProbability(candidate, Role.SEER)) {
                candidate = agent;
            }
        }
        if (candidate != me) {
            estimateSeer = candidate;
            for (Agent agent : humanAgentMap.get(candidate)) {
                if (blackList.contains(agent)) {
                    blackList.remove(agent);
                    possessedList.add(agent);
                }
                whiteList.add(agent);
            }
            for (Agent agent : wolfAgentMap.get(candidate)) {
                grayList.add(agent);
                if (possessedList.contains(agent)) {
                    blackList.add(agent);
                    possessedList.remove(agent);
                }
            }
        }
        return;
    }

    public void chooseVoteCandidate() {
        if (currentGameInfo.getRole() != Role.SEER) {
            werewolves.clear();
        }

        for (Judge j : divinationList) {
            if (j.getResult() == Species.WEREWOLF && (j.getTarget() == me
                    || isKilled(j.getTarget()))) {
                Agent candidate = j.getAgent();
                if (!blackList.contains(candidate) && !possessedList.contains(candidate)) {
                    blackList.add(candidate);
                }
                if (isAlive(candidate) && !werewolves.contains(candidate)) {
                    werewolves.add(candidate);
                }
            }
        }

        if (!blackList.isEmpty()) {
            chooseWerewolf(blackList);
            return;
        }

        if (werewolves.isEmpty()) {
            for (Agent agent : aliveOthers) {
                if (isAlive(agent) && tf.getRoleProbability(agent, Role.WEREWOLF) > 0.3) {
                    werewolves.add(agent);
                }
            }
        }

        if (estimateSeer != me && !grayList.isEmpty()) {
            chooseWerewolf(grayList);
            return;
        }

        if (werewolves.isEmpty()) {
            List<Agent> candidates = aliveOthers;
            candidates.removeAll(whiteList);
            if (!candidates.contains(voteCandidate)) {
                chooseWerewolf(aliveOthers);
            }
        } else {
            if (!werewolves.contains(voteCandidate)) {
                chooseWerewolf(werewolves);
            }
        }
    }

    public void chooseWerewolf(List<Agent> candidateList) {
        double tmp = 0.0;
        Agent candidate = me;
        for (Agent agent : candidateList) {
            if (isAlive(agent)) {
                if (tmp < tf.getRoleProbability(agent, Role.WEREWOLF)
                        && tf.getRoleProbability(agent, Role.SEER) < 0.4) {
                    tmp = tf.getRoleProbability(agent, Role.WEREWOLF);
                    candidate = agent;
                }
            }
        }
        if (candidate != me) {
            voteCandidate = candidate;
        }
    }

    @Override
    public Agent vote() {
        if (!revoted) {
            canTalk = false;
            chooseVoteCandidate();
            considerOthersVote();
            revoted = true;
        } else {
            Map<Agent, Integer> voteMap = new HashMap<>();
            for (Agent agent : latestGameInfo.getAliveAgentList()) {
                voteMap.put(agent, 0);
            }
            for (Vote vote : latestGameInfo.getLatestVoteList()) {
                if (!isAlive(vote.getTarget())) {
                    continue;
                }
                int count = 1;
                count += voteMap.get(vote.getTarget());
                voteMap.put(vote.getTarget(), count);
            }

            for (Agent agent : latestGameInfo.getAliveAgentList()) {
                if (!isAlive(voteCandidate) || (voteMap.get(voteCandidate) < voteMap.get(agent) && agent != me)) {
                    voteCandidate = agent;
                }
            }

            List<Agent> voteCandidateList = new ArrayList<>();
            if (voteMap.get(voteCandidate) > 2) {
                for (Agent agent : aliveOthers) {
                    if (voteMap.get(agent) != null && voteMap.get(voteCandidate) <= voteMap.get(agent) + 1) {
                        voteCandidateList.add(agent);
                    }
                }
            }

            if (voteCandidateList.isEmpty()) {
                voteCandidateList.addAll(aliveOthers);
            }

            Agent candidate = me;
            double percent = 0.0;
            for (Agent agent : voteCandidateList) {
                double tmp = tf.getRoleProbability(agent, Role.WEREWOLF);
                if (percent < tmp) {
                    percent = tmp;
                    candidate = agent;
                }
            }
            if (candidate != me) {
                voteCandidate = candidate;
            }
        }
        super.vote();
        return voteCandidate;
    }

    public void considerOthersVote() {
        //被投票数をエージェントごとに取得
        HashMap<Agent, Integer> termMap = new HashMap<>();
        //自分が投票されているか
        boolean isMeVoted = false;
        int voteMax = 0;
        termMap.put(me, 0);
        termMap.put(voteCandidate, 0);

        for (Agent agent : latestGameInfo.getAliveAgentList()) {
            termMap.put(agent, 0);
        }

        for (Map.Entry<Agent, Agent> entry : votingMap.entrySet()) {
            int count = 1;
            if (termMap.containsKey(entry.getValue())) {
                count += termMap.get(entry.getValue());
                if (entry.getValue() != null) {
                    termMap.put(entry.getValue(), count);
                }
            }
        }

        if (termMap.get(me) > 0) {
            isMeVoted = true;
        }

        //人狼候補を吊れそうであればそちらに票を移す
        for (Map.Entry<Agent, Integer> entry : termMap.entrySet()) {
            if (entry.getKey() == null) {
                continue;
            }
            if (blackList.contains(entry.getKey()) || tf.getRoleProbability(entry.getKey(), Role.WEREWOLF) > 0.3
                    || grayList.contains(entry.getKey())) {
                if (termMap.get(voteCandidate) <= entry.getValue()) {
                    voteCandidate = entry.getKey();
                }
            }
            if (voteMax < entry.getValue()) {
                voteMax = entry.getValue();
            }
        }

        if (voteMax > termMap.get(me)) {
            isMeVoted = false;
        }

        //自分が吊られそうな場合は自分以外で最も票の多いエージェントに投票してつられないように動く
        if (isMeVoted) {
            for (Map.Entry<Agent, Integer> entry : termMap.entrySet()) {
                if (termMap.get(voteCandidate) < entry.getValue() && !entry.getKey().equals(me)
                        && !whiteList.contains(entry.getKey()) &&
                        entry.getKey() != estimateSeer) {
                    voteCandidate = entry.getKey();
                }
            }
        } else if (voteMax == 2) {
            Agent candidate = me;
            double percent = 0.0;
            for (Agent agent : aliveOthers) {
                double tmp = tf.getRoleProbability(agent, Role.WEREWOLF);
                if (percent < tmp && agent != estimateSeer) {
                    percent = tmp;
                    candidate = agent;
                }
            }
            if (candidate != me && percent > 0.3) {
                voteCandidate = candidate;
            }
        }
    }

    @Override
    public Agent divine() {
        return randomSelect(aliveOthers);
    }

    //ゲーム情報
    public GameInfo latestGameInfo;
    // 投票予定map
    Map<Agent, Agent> votingMap;

    int readTalkNum;

    public void setCOPlus(List<Talk> talkList) {
        //自分が生きていれば
        if (latestGameInfo.getAliveAgentList().contains(
                latestGameInfo.getAgent())) {
            for (int i = readTalkNum; i < talkList.size(); i++) {
                Talk talk = talkList.get(i);
                // 発話をパース
                Content content = new Content(talk.getText());//修正

                Agent subject = talk.getAgent();
                Agent target = content.getTarget();//修正
                Role COrole = content.getRole();//修正

                switch (content.getTopic()) {//修正
                    case COMINGOUT:
                        // targetとsubjectが異なっていたら、そのCOは意味がない
                        if (target == subject) {
                            switch (COrole) {
                                case SEER:
                                    break;
                                case POSSESSED:
                                    possessedList.add(target);
                                    break;
                                default:
                                    break;
                            }
                        }
                        break;
                    default:
                        break;
                }
            }
        }
    }

    //votingMap(投票予定先)の更新
    public void setVoteMap(List<Talk> talkList) {
        if (latestGameInfo.getAliveAgentList().contains(
                latestGameInfo.getAgent())) {
            for (int i = readTalkNum; i < talkList.size(); i++) {
                Talk talk = talkList.get(i);
                // 発話をパース
                Content content = new Content(talk.getText());//修正

                Agent subject = talk.getAgent();
                Agent target = content.getTarget();//修正

                if (content.getTopic() == Topic.VOTE) {//修正
                    if (latestGameInfo.getAliveAgentList().contains(target)) {// vote対象が生きていないなら意味ない
                        votingMap.put(subject, target);
                    }
                }
            }
        }
    }

    @Override
    public void AnalysisOfGuess(GameInfo gameInfo) {
        super.AnalysisOfGuess(gameInfo);
    }
}
